//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "BMP2PPMain.h"
#include "BMP2PPAboutForm.h"
#include "BMP2PPProcs.h"
//---------------------------------------------------------------------------
#include <vcl/clipbrd.hpp>
#include <vcl/inifiles.hpp>
#include <dir.h>
#pragma link "sampreg"
#pragma link "tclipboardviewer"
#pragma resource "*.dfm"
TBMP2PPMainForm *BMP2PPMainForm;
//---------------------------------------------------------------------------
#pragma codestring "This executable copyright (C) M. de Kogel, 1997"
#define Program_Version	0x110
void TBMP2PPMainForm::PowerPaintToBitmap (Graphics::TBitmap *bitmap)
{
 int width,height;
 switch (PowerPaintDataLength)
 {
  case 1:
   width=240;
   height=160;
   break;
  case 4:
   width=480;
   height=320;
   break;
  default:
   width=480;
   height=640;
   break;
 }
 byte *bmp=new byte[width*height/2];
 int palette=InPaletteComboBox->ItemIndex;
 if (palette<0) palette=0;
 if (palette>3) palette=3;
 pp2bmp (PowerPaintData,width,height,bmp,Palettes[palette]);
 SetTBitmapBits (bitmap,
                 4, 16,
                 width,
                 width, height,
                 bmp, Palettes[palette]);
 delete[] bmp;
}
//---------------------------------------------------------------------------
__fastcall TBMP2PPMainForm::TBMP2PPMainForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TBMP2PPMainForm::StretchCheckBoxClick(TObject *Sender)
{
 bool checked=((TCheckBox*)Sender)->Checked;
 if (Sender==StretchBitmapCheckBox)
  BitmapImage->Stretch=checked;
 else if (Sender==StretchPowerPaintCheckBox)
  PowerPaintImage->Stretch=checked;
}
//---------------------------------------------------------------------------
void __fastcall TBMP2PPMainForm::FullWindowBitBtnClick(TObject *Sender)
{
 TImage *image;
 TBitmapForm *form;
 if (Sender==BitmapFullWindowBitBtn)
 {
  image=BitmapImage;
  if (FullScreenBitmapForm && !FullScreenBitmapFormShowing)
  {
   delete FullScreenBitmapForm;
   FullScreenBitmapForm=NULL;
  }
  if (!FullScreenBitmapForm)
  {
   FullScreenBitmapForm=new TBitmapForm(this);
   FullScreenBitmapForm->IsBitmapForm=true;
   FullScreenBitmapForm->Caption="Bitmap image";
  }
  form=FullScreenBitmapForm;
  FullScreenBitmapFormShowing=true;
 }
 else
 {
  image=PowerPaintImage;
  if (FullScreenPowerPaintForm && !FullScreenPowerPaintFormShowing)
  {
   delete FullScreenPowerPaintForm;
   FullScreenPowerPaintForm=NULL;
  }
  if (!FullScreenPowerPaintForm)
  {
   FullScreenPowerPaintForm=new TBitmapForm(this);
   FullScreenPowerPaintForm->IsBitmapForm=false;
   FullScreenPowerPaintForm->Caption="PowerPaint image";
  }
  form=FullScreenPowerPaintForm;
  FullScreenPowerPaintFormShowing=true;
 }
 if (image->Picture->Bitmap->Width>0 && image->Picture->Bitmap->Height>0)
 {
  int width=form->Width-form->Image->Width;
  int height=form->Height-form->Image->Height;
  float xmul=((float)Screen->Width*9/10-width)/image->Picture->Bitmap->Width;
  float ymul=((float)Screen->Height*9/10-height)/image->Picture->Bitmap->Height;
  if (xmul>ymul) xmul=ymul;
  form->Width=width+xmul*image->Picture->Bitmap->Width;
  form->Height=height+xmul*image->Picture->Bitmap->Height;
 }
 form->Image->Picture->Bitmap->Assign(image->Picture->Bitmap);
 form->Show ();
}
//---------------------------------------------------------------------------
void __fastcall TBMP2PPMainForm::FormCreate(TObject *Sender)
{
 static int FiltersInit[7][11] =
 {
  { 12,0, 1,1,1, 1,4,1, 1,1,1 },          /* Smooth                         */
  { 19,0, 2,2,2, 2,3,2, 2,2,2 },          /* Smooth +                       */
  { 2,0, 0,-1,0, -1,6,-1, 0,-1,0 },       /* Detail                         */
  { 2,0, -1,-1,-1, -1,10,-1, -1,-1,-1 },  /* Edge enhance                   */
  { 1,0, -1,-1,-1, -1,9,-1, -1,-1,-1 },   /* Edge enhance +                 */
  { 1,0, -1,-1,-1, -1,8,-1, -1,-1,-1 },   /* Find edges                     */
  { 1,255, -1,-1,-1, -1,8,-1, -1,-1,-1 }  /* Contour                        */
 };
 static byte PalettesInit[4][16*3]=
 {
  /* Coleco ADAM's TMS9918 palette */
  {
     0,  0,  0,    0,  0,  0,   71,183, 59,  124,207,111,
    93, 78,255,  128,114,255,  182, 98, 71,   93,200,237,
   215,107, 72,  251,143,108,  195,205, 65,  211,218,118,
    62,159, 47,  182,100,199,  204,204,204,  255,255,255
  },
  /* Default V9938 palette */
  {
     0,  0,  0,    0,  0,  0,   32,192, 32,   96,224, 96,
    32, 32,224,   64, 96,224,  160, 32, 32,   64,192,224,
   224, 32, 32,  224, 96, 96,  192,192, 32,  192,192,128,
    32,128, 32,  192, 64,160,  160,160,160,  224,224,224
  },
  /* TMS9918 Black & White palette */
  {
     0,  0,  0,    0,  0,  0,  136,136,136,  172,172,172,
   102,102,102,  134,134,134,  120,120,120,  172,172,172,
   136,136,136,  172,172,172,  187,187,187,  205,205,205,
   118,118,118,  135,135,135,  204,204,204,  255,255,255
  },
  /* V9938 Black & White palette */
  {
     0,  0,  0,    0,  0,  0,  144,144,144,  195,195,195,
    60, 60, 60,  115,115,115,   80, 80, 80,  178,178,178,
   102,102,102,  153,153,153,  198,198,198,  211,211,211,
   100,100,100,  129,129,129,  182,182,182,  255,255,255
  }
 };
 Filters[0]=NULL;
 Filters[1]=FiltersInit[0];
 Filters[2]=FiltersInit[1];
 Filters[3]=FiltersInit[2];
 Filters[4]=FiltersInit[3];
 Filters[5]=FiltersInit[4];
 Filters[6]=FiltersInit[5];
 Filters[7]=FiltersInit[6];
 Palettes[0]=PalettesInit[0];
 Palettes[1]=PalettesInit[1];
 Palettes[2]=PalettesInit[2];
 Palettes[3]=PalettesInit[3];
 InPaletteComboBox->ItemIndex=0;
 CentreComboBox->ItemIndex=0;
 FilterComboBox->ItemIndex=0;
 DitherComboBox->ItemIndex=3;
 ScaleComboBox->ItemIndex=0;
 FullScreenBitmapForm=NULL;
 FullScreenPowerPaintForm=NULL;
 FullScreenBitmapFormShowing=false;
 FullScreenPowerPaintFormShowing=false;
 Application->OnHint=&OnHint;
 PowerPaintData=new byte[10240];
 memset (PowerPaintData,0,10240);
 PowerPaintDataLength=1;
 PowerPaintToBitmap (PowerPaintImage->Picture->Bitmap);
 cfPowerPaint=RegisterClipboardFormat ("PowerPaint Picture");
 if (!ReadOptionsFromIniFile())
  ReadMeItemClick(ReadMeMenu);
 DrawClipboard (ClipboardViewer);
}
//---------------------------------------------------------------------------
void TBMP2PPMainForm::BitmapFormDestroyed (TBitmapForm *bitmapForm)
{
 if (bitmapForm->IsBitmapForm)
  FullScreenBitmapFormShowing=false;
 else
  FullScreenPowerPaintFormShowing=false;
}
//---------------------------------------------------------------------------
void __fastcall TBMP2PPMainForm::ExitItemClick(TObject *Sender)
{
 Close ();
}
//---------------------------------------------------------------------------
void __fastcall TBMP2PPMainForm::FormDestroy(TObject *Sender)
{
 if (FullScreenBitmapFormShowing)
  FullScreenBitmapForm->Close();
 if (FullScreenPowerPaintFormShowing)
  FullScreenPowerPaintForm->Close();
 if (PowerPaintData)
  delete[] PowerPaintData;
 SaveOptionsToIniFile ();
}
//---------------------------------------------------------------------------
void __fastcall TBMP2PPMainForm::BitmapOpenItemClick(TObject *Sender)
{
 OpenDialogue->Filter="Bitmap images|*.bmp";
 OpenDialogue->DefaultExt="bmp";
 if (OpenDialogue->Execute())
 {
  TMemoryStream *MemoryStream=new TMemoryStream;
  try
  {
   MemoryStream->LoadFromFile (OpenDialogue->FileName);
   BitmapImage->Picture->Bitmap->LoadFromStream (MemoryStream);
  }
  catch (Exception &exception)
  {
   Application->MessageBox ((AnsiString("Error opening ")+OpenDialogue->FileName).c_str(),"BMP2PP Error",MB_OK);
  }
  delete MemoryStream;
 }
}
//---------------------------------------------------------------------------
void __fastcall TBMP2PPMainForm::BitmapSaveItemClick(TObject *Sender)
{
 if (BitmapImage->Picture->Bitmap->Empty) return;
 SaveDialogue->Filter="Bitmap images|*.bmp";
 SaveDialogue->DefaultExt="bmp";
 if (SaveDialogue->Execute())
 {
  try
  {
   BitmapImage->Picture->SaveToFile (SaveDialogue->FileName);
  }
  catch (Exception &exception)
  {
   Application->MessageBox ((AnsiString("Error saving ")+SaveDialogue->FileName).c_str(),"BMP2PP Error",MB_OK);
  }
 }
}
//---------------------------------------------------------------------------
void __fastcall TBMP2PPMainForm::BitmapCopyItemClick(TObject *Sender)
{
 if (BitmapImage->Picture->Bitmap->Empty) return;
 TClipboard *clipboard=new TClipboard;
 clipboard->Assign (BitmapImage->Picture->Bitmap);
 delete clipboard;
}
//---------------------------------------------------------------------------
void __fastcall TBMP2PPMainForm::BitmapPasteItemClick(TObject *Sender)
{
 TClipboard *clipboard=new TClipboard;
 BitmapImage->Picture->Bitmap->Assign (clipboard);
 delete clipboard;
}
//---------------------------------------------------------------------------
void __fastcall TBMP2PPMainForm::OnHint (TObject *Sender)
{
 if (Screen->ActiveForm==this)
  StatusBar->SimpleText=Application->Hint;
 else if (Screen->ActiveForm==FullScreenBitmapForm)
  FullScreenBitmapForm->StatusBar->SimpleText=Application->Hint;
 else if (Screen->ActiveForm==FullScreenPowerPaintForm)
  FullScreenPowerPaintForm->StatusBar->SimpleText=Application->Hint;
 else if (Screen->ActiveForm==ReadMeForm)
  ReadMeForm->StatusBar->SimpleText=Application->Hint;
}
//---------------------------------------------------------------------------
void __fastcall TBMP2PPMainForm::AboutItemClick(TObject *Sender)
{
 TAboutBox *aboutBox=new TAboutBox(this);
 aboutBox->ShowModal ();
 delete aboutBox;
}
//---------------------------------------------------------------------------
void __fastcall TBMP2PPMainForm::PowerPaintOpenItemClick(TObject *Sender)
{
 OpenDialogue->Filter="PowerPaint images|*.pp";
 OpenDialogue->DefaultExt="pp";
 if (!OpenDialogue->Execute()) return;
 TFileStream *fileStream=new TFileStream (OpenDialogue->FileName,fmOpenRead);
 int len=fileStream->Size;
 if (len!=10240 && len!=4*10240 && len!=8*10240)
 {
  Application->MessageBox ("The selected file doesn't appear to be a PowerPaint file",Application->Title.c_str(),MB_OK);
  delete fileStream;
  return;
 }
 delete[] PowerPaintData;
 PowerPaintDataLength=len/10240;
 PowerPaintData=new byte[len];
 fileStream->Read (PowerPaintData,len);
 delete fileStream;
 PowerPaintToBitmap (PowerPaintImage->Picture->Bitmap);
}
//---------------------------------------------------------------------------
void __fastcall TBMP2PPMainForm::PowerPaintSaveItemClick(TObject *Sender)
{
 SaveDialogue->Filter="PowerPaint images|*.pp";
 SaveDialogue->DefaultExt="pp";
 if (!SaveDialogue->Execute()) return;
 TFileStream *fileStream=new TFileStream (SaveDialogue->FileName,fmCreate);
 fileStream->Write (PowerPaintData,PowerPaintDataLength*10240);
 delete fileStream;
}
//---------------------------------------------------------------------------
void __fastcall TBMP2PPMainForm::PowerPaintCopyItemClick(TObject *Sender)
{
 HGLOBAL hg=GlobalAlloc (GMEM_MOVEABLE,PowerPaintDataLength*10240);
 void *p=GlobalLock (hg);
 memcpy (p,PowerPaintData,PowerPaintDataLength*10240);
 GlobalUnlock (hg);
 TClipboard *clipboard=new TClipboard;
 clipboard->Open ();
 clipboard->SetAsHandle ((short)cfPowerPaint,(int)hg);
 clipboard->Assign (PowerPaintImage->Picture->Bitmap);
 clipboard->Close ();
 delete clipboard;
}
//---------------------------------------------------------------------------
void __fastcall TBMP2PPMainForm::PowerPaintPasteItemClick(
	TObject *Sender)
{
 TClipboard *clipboard=new TClipboard;
 HGLOBAL hg=(HGLOBAL) clipboard->GetAsHandle((short)cfPowerPaint);
 delete clipboard;
 if (!hg) return;
 int len=GlobalSize(hg)/10240;
 if (len!=1 && len!=4 && len!=8) return;
 void *p=GlobalLock (hg);
 delete[] PowerPaintData;
 PowerPaintData=new byte[len*10240];
 memcpy (PowerPaintData,p,len*10240);
 GlobalUnlock (hg);
 PowerPaintDataLength=len;
 PowerPaintToBitmap (PowerPaintImage->Picture->Bitmap);
}
//---------------------------------------------------------------------------
void __fastcall TBMP2PPMainForm::PP2BMPBitBtnClick(TObject *Sender)
{
 PowerPaintToBitmap (BitmapImage->Picture->Bitmap);
}
//---------------------------------------------------------------------------
static int bmp2ppCallback (char *message,int progress)
{
 return BMP2PPMainForm->bmp2ppCallback (message,progress);
}
int TBMP2PPMainForm::bmp2ppCallback (char *message,int progress)
{
 if (message)
  BMP2PPMainForm->ProgressForm->WhatAmIDoingLabel->Caption=AnsiString(message)+AnsiString("...");
 if (progress>=0)
  BMP2PPMainForm->ProgressForm->MainGauge->Progress=progress;
 Application->ProcessMessages ();
 return (ProgressForm->WantToClose)? 0:1;
}

void __fastcall TBMP2PPMainForm::BMP2PPBitBtnClick(TObject *Sender)
{
 int BitmapWidth,BitmapHeight;
 byte *pBitmapBits;
 if (GetTBitmapBits (BitmapImage->Picture->Bitmap,&BitmapWidth,
 					 &BitmapHeight,&pBitmapBits)<0)
  return;
 byte *pp=new byte[81920];
 int palette=InPaletteComboBox->ItemIndex;
 if (palette<0) palette=0;
 if (palette>3) palette=3;
 int filter=FilterComboBox->ItemIndex;
 if (filter<0) filter=0;
 if (filter>7) filter=7;
 int w1,w2=5,w3=3,w4=1;
 char *p=DitheringWeightsMaskEdit->Text.c_str();
 w1=atoi(p);
 p=strchr(p,',');
 if (p)
 {
  w2=atoi(p+1);
  p=strchr(p+1,',');
  if (p)
  {
   w3=atoi(p+1);
   p=strchr(p+1,',');
   if (p) w4=atoi(p+1);
  }
 }
 ProgressForm=new TProgressForm(this);
 Enabled=false;
 ProgressForm->Show ();
 int ok=bmp2pp
  (pBitmapBits,
   &BitmapWidth,&BitmapHeight,
   pp,
   Palettes[palette],
   DitherComboBox->ItemIndex,
   MaxErrorSpinEdit->Value,
   w1,w2,w3,w4,
   NoiseLevelSpinEdit->Value,
   ScaleComboBox->ItemIndex,
   InterpolateCheckBox->Checked? 1:0,
   CentreComboBox->ItemIndex,
   ((float)GammaSpinEdit->Value)/100,
   BrightnessSpinEdit->Value,
   GreyscaleCheckBox->Checked? 1:0,
   Filters[filter],
   MonochromeCheckBox->Checked? 1:0,
   ::bmp2ppCallback);
 Enabled=true;
 delete ProgressForm;
 delete[] pBitmapBits;
 if (ok)
 {
  if (BitmapHeight<=160 && BitmapWidth<=240) PowerPaintDataLength=1;
  else PowerPaintDataLength=(BitmapHeight<=320)? 4:8;
  delete[] PowerPaintData;
  PowerPaintData=new byte[PowerPaintDataLength*10240];
  if (PowerPaintDataLength==1)
  {
   memcpy (PowerPaintData,pp+5120,5120);
   memcpy (PowerPaintData+5120,pp,5120);
  }
  else
   memcpy (PowerPaintData,pp,PowerPaintDataLength*10240);
  PowerPaintToBitmap (PowerPaintImage->Picture->Bitmap);
 }
 delete[] pp;
}
//---------------------------------------------------------------------------
void __fastcall TBMP2PPMainForm::ReadMeItemClick(TObject *Sender)
{
 ReadMeForm=new TReadMeForm(this);
 ReadMeForm->ShowModal ();
 delete ReadMeForm;
}
//---------------------------------------------------------------------------
#define Section	"BMP2PP"
bool TBMP2PPMainForm::ReadOptionsFromIniFile (void)
{
 char s[MAXPATH];
 char drive[MAXDRIVE];
 char dir[MAXDIR];
 fnsplit (Application->ExeName.c_str(),drive,dir,NULL,NULL);
 fnmerge (s,drive,dir,"BMP2PP",".ini");
 TIniFile *iniFile=new TIniFile (s);
 InPaletteComboBox->ItemIndex=iniFile->ReadInteger (Section,"Palette",0);
 GammaSpinEdit->Value=iniFile->ReadInteger (Section,"Gamma",100);
 BrightnessSpinEdit->Value=iniFile->ReadInteger (Section,"Brightness",50);
 GreyscaleCheckBox->Checked=iniFile->ReadBool (Section,"Greyscale",false);
 MonochromeCheckBox->Checked=iniFile->ReadBool (Section,"Monochrome",false);
 CentreComboBox->ItemIndex=iniFile->ReadInteger (Section,"Centre",0);
 FilterComboBox->ItemIndex=iniFile->ReadInteger (Section,"Filter",0);
 DitherComboBox->ItemIndex=iniFile->ReadInteger (Section,"Dither",3);
 MaxErrorSpinEdit->Value=iniFile->ReadInteger (Section,"MaximumError",32);
 NoiseLevelSpinEdit->Value=iniFile->ReadInteger (Section,"NoiseLevel",50);
 DitheringWeightsMaskEdit->Text=iniFile->ReadString (Section,"DitherWeights","07,05,03,01");
 ScaleComboBox->ItemIndex=iniFile->ReadInteger (Section,"Scale",0);
 InterpolateCheckBox->Checked=iniFile->ReadBool (Section,"Interpolation",true);
 StretchBitmapCheckBox->Checked=iniFile->ReadBool (Section,"StretchBitmapImage",false);
 StretchPowerPaintCheckBox->Checked=iniFile->ReadBool (Section,"StretchPowerPaintImage",false);
 AnsiString a=iniFile->ReadString (Section,"cwd","");
 if (a.c_str()[0])
 {
  chdir (a.c_str());
  setdisk (tolower(a.c_str()[0])-'a');
 }
 int version=iniFile->ReadInteger (Section,"Version",0);
 delete iniFile;
 return version==Program_Version;
}
void TBMP2PPMainForm::SaveOptionsToIniFile (void)
{
 char s[MAXPATH];
 char drive[MAXDRIVE];
 char dir[MAXDIR];
 fnsplit (Application->ExeName.c_str(),drive,dir,NULL,NULL);
 fnmerge (s,drive,dir,"BMP2PP",".ini");
 TIniFile *iniFile=new TIniFile (s);
 iniFile->WriteInteger (Section,"Version",Program_Version);
 iniFile->WriteInteger (Section,"Palette",InPaletteComboBox->ItemIndex);
 iniFile->WriteInteger (Section,"Gamma",GammaSpinEdit->Value);
 iniFile->WriteInteger (Section,"Brightness",BrightnessSpinEdit->Value);
 iniFile->WriteBool (Section,"Greyscale",GreyscaleCheckBox->Checked);
 iniFile->WriteBool (Section,"Monochrome",MonochromeCheckBox->Checked);
 iniFile->WriteInteger (Section,"Centre",CentreComboBox->ItemIndex);
 iniFile->WriteInteger (Section,"Filter",FilterComboBox->ItemIndex);
 iniFile->WriteInteger (Section,"Dither",DitherComboBox->ItemIndex);
 iniFile->WriteInteger (Section,"MaximumError",MaxErrorSpinEdit->Value);
 iniFile->WriteInteger (Section,"NoiseLevel",NoiseLevelSpinEdit->Value);
 int w1,w2=5,w3=3,w4=1;
 char *p=DitheringWeightsMaskEdit->Text.c_str();
 w1=atoi(p);
 p=strchr(p,',');
 if (p)
 {
  w2=atoi(p+1);
  p=strchr(p+1,',');
  if (p)
  {
   w3=atoi(p+1);
   p=strchr(p+1,',');
   if (p) w4=atoi(p+1);
  }
 }
 sprintf (s,"%02u,%02u,%02u,%02u",w1,w2,w3,w4);
 iniFile->WriteString (Section,"DitherWeights",s);
 iniFile->WriteInteger (Section,"Scale",ScaleComboBox->ItemIndex);
 iniFile->WriteBool (Section,"Interpolation",InterpolateCheckBox->Checked);
 iniFile->WriteBool (Section,"StretchBitmapImage",StretchBitmapCheckBox->Checked);
 iniFile->WriteBool (Section,"StretchPowerPaintImage",StretchPowerPaintCheckBox->Checked);
 getcwd (s,sizeof(s));
 iniFile->WriteString (Section,"cwd",s);
 delete iniFile;
}
void __fastcall TBMP2PPMainForm::DrawClipboard(TObject *Sender)
{
 BitmapPasteSpeedButton->Enabled=BitmapPasteMenu->Enabled=
 	IsClipboardFormatAvailable (CF_BITMAP);
 PowerPaintPasteSpeedButton->Enabled=PowerPaintPasteMenu->Enabled=
 	IsClipboardFormatAvailable (cfPowerPaint);
}
//---------------------------------------------------------------------------
